Index: sasmodels/models/lib/sas_3j1x_x.c
===================================================================
--- sasmodels/models/lib/sas_3j1x_x.c	(revision 473a9f131b0c8e4ae5fb862b046d8e30d4eddedb)
+++ sasmodels/models/lib/sas_3j1x_x.c	(revision 473a9f131b0c8e4ae5fb862b046d8e30d4eddedb)
@@ -0,0 +1,56 @@
+/**
+* Spherical Bessel function 3*j1(x)/x
+*
+* Used for low q to avoid cancellation error.
+* Note that the values differ from sasview ~ 5e-12 rather than 5e-14, but
+* in this case it is likely cancellation errors in the original expression
+* using double precision that are the source.
+*/
+double sas_3j1x_x(double q);
+
+// The choice of the number of terms in the series and the cutoff value for
+// switching between series and direct calculation depends on the numeric
+// precision.
+//
+// Point where direct calculation reaches machine precision:
+//
+//   single machine precision eps 3e-8 at qr=1.1 **
+//   double machine precision eps 4e-16 at qr=1.1
+//
+// Point where Taylor series reaches machine precision (eps), where taylor
+// series matches direct calculation (cross) and the error at that point:
+//
+//   prec   n eps  cross  error
+//   single 3 0.28  0.4   6.2e-7
+//   single 4 0.68  0.7   2.3e-7
+//   single 5 1.18  1.2   7.5e-8
+//   double 3 0.01  0.03  2.3e-13
+//   double 4 0.06  0.1   3.1e-14
+//   double 5 0.16  0.2   5.0e-15
+//
+// ** Note: relative error on single precision starts increase on the direct
+// method at qr=1.1, rising from 3e-8 to 5e-5 by qr=1e3.  This should be
+// safe for the sans range, with objects of 100 nm supported to a q of 0.1
+// while maintaining 5 digits of precision.  For usans/sesans, the objects
+// are larger but the q is smaller, so again it should be fine.
+//
+// See explore/sph_j1c.py for code to explore these ranges.
+
+// Use 4th order series
+#if FLOAT_SIZE>4
+#define SPH_J1C_CUTOFF 0.1
+#else
+#define SPH_J1C_CUTOFF 0.7
+#endif
+
+double sas_3j1x_x(double q)
+{
+    if (q < SPH_J1C_CUTOFF) {
+        const double q2 = q*q;
+        return (1.0 + q2*(-3./30. + q2*(3./840. + q2*(-3./45360.))));// + q2*(3./3991680.)))));
+    } else {
+        double sin_q, cos_q;
+        SINCOS(q, sin_q, cos_q);
+        return 3.0*(sin_q/q - cos_q)/(q*q);
+    }
+}
Index: sasmodels/models/lib/sas_J0.c
===================================================================
--- sasmodels/models/lib/sas_J0.c	(revision 1596de320c8f962693aa46eb70d0b5bec0e6c601)
+++ sasmodels/models/lib/sas_J0.c	(revision c8902ac8c2f740f2cd6d59d72c25f8957b7bdd8e)
@@ -55,5 +55,5 @@
 #if FLOAT_SIZE>4
 //Cephes double precission
-double j0(double x);
+double cephes_j0(double x);
 
  constant double PPJ0[8] = {
@@ -147,5 +147,5 @@
   };
 
-double j0(double x)
+double cephes_j0(double x)
 {
     double w, z, p, q, xn;
@@ -186,5 +186,5 @@
 #else
 //Cephes single precission
-float j0f(float x);
+float cephes_j0f(float x);
 
  constant float MOJ0[8] = {
@@ -221,5 +221,5 @@
  };
 
-float j0f(float x)
+float cephes_j0f(float x)
 {
     float xx, w, z, p, q, xn;
@@ -257,6 +257,6 @@
 
 #if FLOAT_SIZE>4
-#define sas_J0 j0
+#define sas_J0 cephes_j0
 #else
-#define sas_J0 j0f
+#define sas_J0 cephes_j0f
 #endif
Index: sasmodels/models/lib/sas_J1.c
===================================================================
--- sasmodels/models/lib/sas_J1.c	(revision 1596de320c8f962693aa46eb70d0b5bec0e6c601)
+++ sasmodels/models/lib/sas_J1.c	(revision 473a9f131b0c8e4ae5fb862b046d8e30d4eddedb)
@@ -42,5 +42,5 @@
 #if FLOAT_SIZE>4
 //Cephes double pression function
-double j1(double x);
+double cephes_j1(double x);
 
 constant double RPJ1[8] = {
@@ -106,5 +106,5 @@
     0.0 };
 
-double j1(double x)
+double cephes_j1(double x)
 {
 
@@ -144,5 +144,5 @@
 #else
 //Single precission version of cephes
-float j1f(float x);
+float cephes_j1f(float x);
 
 constant float JPJ1[8] = {
@@ -179,5 +179,5 @@
     };
 
-float j1f(float x)
+float cephes_j1f(float x)
 {
 
@@ -211,12 +211,12 @@
 
 #if FLOAT_SIZE>4
-#define sas_J1 j1
+#define sas_J1 cephes_j1
 #else
-#define sas_J1 j1f
+#define sas_J1 cephes_j1f
 #endif
 
 //Finally J1c function that equals 2*J1(x)/x
-double sas_J1c(double x);
-double sas_J1c(double x)
+double sas_2J1x_x(double x);
+double sas_2J1x_x(double x)
 {
     return (x != 0.0 ) ? 2.0*sas_J1(x)/x : 1.0;
Index: sasmodels/models/lib/sas_JN.c
===================================================================
--- sasmodels/models/lib/sas_JN.c	(revision 1596de320c8f962693aa46eb70d0b5bec0e6c601)
+++ sasmodels/models/lib/sas_JN.c	(revision c8902ac8c2f740f2cd6d59d72c25f8957b7bdd8e)
@@ -50,6 +50,6 @@
 #if FLOAT_SIZE > 4
 
-double jn( int n, double x );
-double jn( int n, double x ) {
+double cephes_jn( int n, double x );
+double cephes_jn( int n, double x ) {
 
     // PAK: seems to be machine epsilon/2
@@ -75,9 +75,9 @@
 
     if( n == 0 )
-        return( sign * j0(x) );
+        return( sign * cephes_j0(x) );
     if( n == 1 )
-        return( sign * j1(x) );
+        return( sign * cephes_j1(x) );
     if( n == 2 )
-        return( sign * (2.0 * j1(x) / x  -  j0(x)) );
+        return( sign * (2.0 * cephes_j1(x) / x  -  cephes_j0(x)) );
 
     if( x < MACHEP )
@@ -112,7 +112,7 @@
 
     if( fabs(pk) > fabs(pkm1) )
-        ans = j1(x)/pk;
+        ans = cephes_j1(x)/pk;
     else
-        ans = j0(x)/pkm1;
+        ans = cephes_j0(x)/pkm1;
 
     return( sign * ans );
@@ -121,6 +121,6 @@
 #else
 
-float jnf(int n, float x);
-float jnf(int n, float x)
+float cephes_jnf(int n, float x);
+float cephes_jnf(int n, float x)
 {
     // PAK: seems to be machine epsilon/2
@@ -146,9 +146,9 @@
 
     if( n == 0 )
-        return( sign * j0f(x) );
+        return( sign * cephes_j0f(x) );
     if( n == 1 )
-        return( sign * j1f(x) );
+        return( sign * cephes_j1f(x) );
     if( n == 2 )
-        return( sign * (2.0 * j1f(x) / x  -  j0f(x)) );
+        return( sign * (2.0 * cephes_j1f(x) / x  -  cephes_j0f(x)) );
 
     if( x < MACHEP )
@@ -189,7 +189,7 @@
 
     if( r > ans )  /* if( fabs(pk) > fabs(pkm1) ) */
-        ans = sign * j1f(x)/pk;
+        ans = sign * cephes_j1f(x)/pk;
     else
-        ans = sign * j0f(x)/pkm1;
+        ans = sign * cephes_j0f(x)/pkm1;
     return( ans );
 }
@@ -197,6 +197,6 @@
 
 #if FLOAT_SIZE>4
-#define sas_JN jn
+#define sas_JN cephes_jn
 #else
-#define sas_JN jnf
+#define sas_JN cephes_jnf
 #endif
Index: sasmodels/models/lib/sas_Si.c
===================================================================
--- sasmodels/models/lib/sas_Si.c	(revision 473a9f131b0c8e4ae5fb862b046d8e30d4eddedb)
+++ sasmodels/models/lib/sas_Si.c	(revision 473a9f131b0c8e4ae5fb862b046d8e30d4eddedb)
@@ -0,0 +1,24 @@
+// integral of sin(x)/x Taylor series approximated to w/i 0.1%
+double sas_Si(double x);
+double sas_Si(double x)
+{
+    if (x >= M_PI*6.2/4.0) {
+        const double xxinv = 1./(x*x);
+        // Explicitly writing factorial values triples the speed of the calculation
+        const double out_cos = (((-720.*xxinv + 24.)*xxinv - 2.)*xxinv + 1.)/x;
+        const double out_sin = (((-5040.*xxinv + 120.)*xxinv - 6.)*xxinv + 1)*xxinv;
+
+        double sin_x, cos_x;
+        SINCOS(x, sin_x, cos_x);
+        return M_PI_2 - cos_x*out_cos - sin_x*out_sin;
+    } else {
+        const double xx = x*x;
+        // Explicitly writing factorial values triples the speed of the calculation
+        return (((((-1./439084800.*xx
+            + 1./3265920.)*xx
+            - 1./35280.)*xx
+            + 1./600.)*xx
+            - 1./18.)*xx
+            + 1.)*x;
+    }
+}
Index: sasmodels/models/lib/sas_gamma.c
===================================================================
--- sasmodels/models/lib/sas_gamma.c	(revision 1596de320c8f962693aa46eb70d0b5bec0e6c601)
+++ sasmodels/models/lib/sas_gamma.c	(revision 97f9b46b6cdd9fb99c9a5802c207f0492945d67f)
@@ -5,4 +5,5 @@
 We use gamma definition Gamma(t + 1) = t * Gamma(t) to compute
 to function for values lower than 1.0. Namely Gamma(t) = 1/t * Gamma(t + 1)
+For t < 0, we use Gamma(t) = pi / ( Gamma(1 - t) * sin(pi * t) )
 */
 
@@ -137,3 +138,15 @@
 
 
-inline double sas_gamma( double x) { return tgamma(x+1)/x; }
+inline double sas_gamma(double x)
+{
+    // Note: the builtin tgamma can give slow and unreliable results for x<1.
+    // The following transform extends it to zero and to negative values.
+    // It should return NaN for zero and negative integers but doesn't.
+    // The accuracy is okay but not wonderful for negative numbers, maybe
+    // one or two digits lost in the calculation. If higher accuracy is
+    // needed, you could test the following loop:
+    //    double norm = 1.;
+    //    while (x<1.) { norm*=x; x+=1.; }
+    //    return tgamma(x)/norm;
+    return (x<0. ? M_PI/tgamma(1.-x)/sin(M_PI*x) : tgamma(x+1)/x);
+}
Index: sasmodels/models/lib/sphere_form.c
===================================================================
--- sasmodels/models/lib/sphere_form.c	(revision ba32cddebeff04b66d828ca58b1843244d4425fb)
+++ sasmodels/models/lib/sphere_form.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -9,5 +9,5 @@
 double sphere_form(double q, double radius, double sld, double solvent_sld)
 {
-    const double fq = sphere_volume(radius) * sph_j1c(q*radius);
+    const double fq = sphere_volume(radius) * sas_3j1x_x(q*radius);
     const double contrast = (sld - solvent_sld);
     return 1.0e-4*square(contrast * fq);
Index: sasmodels/models/lib/wrc_cyl.c
===================================================================
--- sasmodels/models/lib/wrc_cyl.c	(revision ba32cddebeff04b66d828ca58b1843244d4425fb)
+++ sasmodels/models/lib/wrc_cyl.c	(revision 92ce163837b3c51ecc732713d4a5ea719c037b29)
@@ -14,6 +14,5 @@
     //return t;
 
-    return pow( (1.0 + (x/3.12)*(x/3.12) +
-         (x/8.67)*(x/8.67)*(x/8.67)),(0.176/3.0) );
+    return pow(1.0+square(x/3.12)+cube(x/8.67), 0.176/3.0);
 }
 
@@ -23,6 +22,6 @@
 {
     const double r = b/L;
-    return (L*b/6.0) *
-           (1.0 - r*1.5  + 1.5*r*r - 0.75*r*r*r*(1.0 - exp(-2.0/r)));
+    return (L*b/6.0) * (1.0 + r*(-1.5 + r*(1.5 + r*0.75*expm1(-2.0/r))));
+
 }
 
@@ -41,5 +40,5 @@
 }
 
-static inline double
+static double
 sech_WR(double x)
 {
@@ -51,5 +50,4 @@
 {
     double C;
-    const double onehalf = 1.0/2.0;
 
     if( L/b > 10.0) {
@@ -86,5 +84,5 @@
 
     const double t2 = (2.0*b4*(((-1.0) + pow((double)M_E,(-(Rg02/b2))) +
-         Rg02/b2))*((1.0 + onehalf*(((-1.0) -
+         Rg02/b2))*((1.0 + 0.5*(((-1.0) -
          tanh((-C4 + Rgb/C5)))))));
 
@@ -112,9 +110,9 @@
 
     const double t9 = (2.0*b4*(((2.0*q0*Rg2)/b -
-         (2.0*pow((double)M_E,(-(Rg02/b2)))*q0*Rg2)/b))*((1.0 + onehalf*(((-1.0) -
+         (2.0*pow((double)M_E,(-(Rg02/b2)))*q0*Rg2)/b))*((1.0 + 0.5*(((-1.0) -
          tanh(((-C4) + Rgb)/C5))))));
 
     const double t10 = (8.0*b4*b*(((-1.0) + pow((double)M_E,(-(Rg02/b2))) +
-         Rg02/b2))*((1.0 + onehalf*(((-1.0) - tanh(((-C4) +
+         Rg02/b2))*((1.0 + 0.5*(((-1.0) - tanh(((-C4) +
          Rgb)/C5))))));
 
@@ -131,5 +129,5 @@
 
     const double t14 = (2.0*b4*(((-1.0) + pow((double)M_E,(-(Rg02/b2))) +
-          Rg02/b2))*((1.0 + onehalf*(((-1.0) - tanh(((-C4) +
+          Rg02/b2))*((1.0 + 0.5*(((-1.0) - tanh(((-C4) +
           Rgb)/C5))))));
 
@@ -140,9 +138,9 @@
 
     double yy = (pow(q0,p1)*(((-((b*M_PI)/(L*q0))) +t1/L +t2/(q04*Rg22) +
-        onehalf*t3*t4)) + (t5*((pow(q0,(p1 - p2))*
+        0.5*t3*t4)) + (t5*((pow(q0,(p1 - p2))*
         (((-pow(q0,(-p1)))*(((b2*M_PI)/(L*q02) +t6/L +t7/(2.0*C5) -
-        t8/(C5*q04*Rg22) + t9/(q04*Rg22) -t10/(q05*Rg22) + onehalf*t11*t12)) -
+        t8/(C5*q04*Rg22) + t9/(q04*Rg22) -t10/(q05*Rg22) + 0.5*t11*t12)) -
         b*p1*pow(q0,((-1.0) - p1))*(((-((b*M_PI)/(L*q0))) + t13/L +
-        t14/(q04*Rg22) + onehalf*t15*((1.0 + tanh(((-C4) +
+        t14/(q04*Rg22) + 0.5*t15*((1.0 + tanh(((-C4) +
         Rgb)/C5)))))))))));
 
@@ -154,5 +152,4 @@
 {
     double C;
-    const double onehalf = 1.0/2.0;
 
     if( L/b > 10.0) {
@@ -201,9 +198,9 @@
     const double t5 = (2.0*b4*(((2.0*q0*Rg2)/b -
          (2.0*pow((double)M_E,(-(Rg02/b2)))*q0*Rg2)/b))*
-         ((1.0 + onehalf*(((-1.0) - tanh(((-C4) +
+         ((1.0 + 0.5*(((-1.0) - tanh(((-C4) +
          Rgb)/C5))))))/(q04*Rg22);
 
     const double t6 = (8.0*b4*b*(((-1.0) + pow((double)M_E,(-(Rg02/b2))) +
-         Rg02/b2))*((1.0 + onehalf*(((-1) - tanh(((-C4) +
+         Rg02/b2))*((1.0 + 0.5*(((-1) - tanh(((-C4) +
          Rgb)/C5))))))/(q05*Rg22);
 
@@ -219,11 +216,11 @@
 
     const double t10 = (2.0*b4*(((-1) + pow((double)M_E,(-(Rg02/b2))) +
-          Rg02/b2))*((1.0 + onehalf*(((-1) - tanh(((-C4) +
+          Rg02/b2))*((1.0 + 0.5*(((-1) - tanh(((-C4) +
           Rgb)/C5))))))/(q04*Rg22);
 
     const double yy = ((-1.0*(t1* ((-pow(q0,-p1)*(((b2*M_PI)/(L*q02) +
-         t2 + t3 - t4 + t5 - t6 + onehalf*t7*t8)) - b*p1*pow(q0,((-1.0) - p1))*
+         t2 + t3 - t4 + t5 - t6 + 0.5*t7*t8)) - b*p1*pow(q0,((-1.0) - p1))*
          (((-((b*M_PI)/(L*q0))) + t9 + t10 +
-         onehalf*((C3*pow(((Rgb)),((-3.0)/miu)) +
+         0.5*((C3*pow(((Rgb)),((-3.0)/miu)) +
          C2*pow(((Rgb)),((-2.0)/miu)) +
          C1*pow(((Rgb)),((-1.0)/miu))))*
Index: sasmodels/models/linear_pearls.c
===================================================================
--- sasmodels/models/linear_pearls.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/linear_pearls.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -19,5 +19,5 @@
 {
     // Pearl volume
-    double pearl_vol = 4.0 /3.0 * M_PI * pow(radius, 3.0);
+    double pearl_vol = M_4PI_3 * cube(radius);
     // Return total volume
     return num_pearls * pearl_vol;;
@@ -35,5 +35,5 @@
     double contrast_pearl = pearl_sld - solvent_sld;
     //each volume
-    double pearl_vol = 4.0 /3.0 * M_PI * pow(radius, 3.0);
+    double pearl_vol = M_4PI_3 * cube(radius);
     //total volume
     double tot_vol = num_pearls * pearl_vol;
@@ -43,14 +43,6 @@
     double separation = edge_sep + 2.0 * radius;
 
-    double x=q*radius;
-
-    // Try Taylor on x*xos(x)
-	// double out_cos = x - pow(x,3)/2 + pow(x,5)/24 - pow(x,7)/720 + pow(x,9)/40320;
-    // psi -= x*out_cos;
-
     //sine functions of a pearl
-    double psi = sin(q * radius);
-    psi -= x * cos(x);
-    psi /= pow((q * radius), 3.0);
+    double psi = sas_3j1x_x(q * radius);
 
     // N pearls contribution
@@ -58,10 +50,8 @@
     n_contrib = num_pearls;
     for(int num=1; num<=n_max; num++) {
-        n_contrib += (2.0*(num_pearls-num)*sinc(q*separation*num));
+        n_contrib += (2.0*(num_pearls-num)*sas_sinx_x(q*separation*num));
     }
     // form factor for num_pearls
-    double form_factor = n_contrib;
-    form_factor *= pow((m_s*psi*3.0), 2.0);
-    form_factor /= (tot_vol * 1.0e4);
+    double form_factor = 1.0e-4 * n_contrib * square(m_s*psi) / tot_vol;
 
     return form_factor;
Index: sasmodels/models/linear_pearls.py
===================================================================
--- sasmodels/models/linear_pearls.py	(revision 40a87fa5096610e24c3ead10299f609e99f093f2)
+++ sasmodels/models/linear_pearls.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -63,5 +63,5 @@
 single = False
 
-source = ["linear_pearls.c"]
+source = ["lib/sas_3j1x_x.c", "linear_pearls.c"]
 
 demo = dict(scale=1.0, background=0.0,
Index: sasmodels/models/mass_fractal.c
===================================================================
--- sasmodels/models/mass_fractal.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/mass_fractal.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -1,48 +1,31 @@
-double form_volume(double radius);
+#define INVALID(p) (p.fractal_dim_mass < 1.0)
 
-double Iq(double q,
-          double radius,
-          double fractal_dim_mass,
-          double cutoff_length);
+static double
+Iq(double q, double radius, double fractal_dim_mass, double cutoff_length)
+{
+    //calculate P(q)
+    const double pq = square(sas_3j1x_x(q*radius));
 
-static double _mass_fractal_kernel(double q,
-          double radius,
-          double fractal_dim_mass,
-          double cutoff_length)
-{
-    // Actively check the argument.
-    if (fractal_dim_mass <= 1.0){
-       return 0.0;
+    //calculate S(q)
+    // S(q) = gamma(D-1) sin((D-1)atan(q c))/q c^(D-1) (1+(q c)^2)^(-(D-1)/2)
+    // lim D->1 [gamma(D-1) sin((D-1) a)] = a
+    // lim q->0 [sin((D-1) atan(q c))/q] = (D-1) c
+    // lim q,D->0,1 [gamma(D-1) sin((D-1)atan(q c))/q] = c
+    double sq;
+    if (q > 0. && fractal_dim_mass > 1.) {
+        const double Dm1 = fractal_dim_mass - 1.0;
+        const double t1 = sas_gamma(Dm1)*sin(Dm1*atan(q*cutoff_length));
+        const double t2 = pow(cutoff_length, Dm1);
+        const double t3 = pow(1.0 + square(q*cutoff_length), -0.5*Dm1);
+        sq = t1 * t2 * t3 / q;
+    } else if (q > 0.) {
+        sq = atan(q*cutoff_length)/q;
+    } else if (fractal_dim_mass > 1.) {
+        const double D = fractal_dim_mass;
+        sq = pow(cutoff_length, D) * sas_gamma(D);
+    } else {
+        sq = cutoff_length;
     }
 
-    //calculate P(q)
-    double pq = sph_j1c(q*radius);
-    pq = pq*pq;
-
-    //calculate S(q)
-    double mmo = fractal_dim_mass-1.0;
-    double sq = sas_gamma(mmo)*sin((mmo)*atan(q*cutoff_length));
-    sq *= pow(cutoff_length, mmo);
-    sq /= pow((1.0 + (q*cutoff_length)*(q*cutoff_length)),(mmo/2.0));
-    sq /= q;
-
-    //combine and return
-    double result = pq * sq;
-
-    return result;
+    return pq * sq;
 }
-double form_volume(double radius){
-
-    return 1.333333333333333*M_PI*radius*radius*radius;
-}
-
-double Iq(double q,
-          double radius,
-          double fractal_dim_mass,
-          double cutoff_length)
-{
-    return _mass_fractal_kernel(q,
-           radius,
-           fractal_dim_mass,
-           cutoff_length);
-}
Index: sasmodels/models/mass_fractal.py
===================================================================
--- sasmodels/models/mass_fractal.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/mass_fractal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -78,12 +78,13 @@
 
 # pylint: disable=bad-whitespace, line-too-long
-#             ["name", "units", default, [lower, upper], "type","description"],
-parameters = [["radius",        "Ang",  10.0, [0.0, inf], "", "Particle radius"],
-              ["fractal_dim_mass",      "",      1.9, [1.0, 6.0], "", "Mass fractal dimension"],
-              ["cutoff_length", "Ang", 100.0, [0.0, inf], "", "Cut-off length"],
-             ]
+#   ["name", "units", default, [lower, upper], "type","description"],
+parameters = [
+    ["radius",           "Ang",  10.0, [0.0, inf], "", "Particle radius"],
+    ["fractal_dim_mass", "",      1.9, [1.0, 6.0], "", "Mass fractal dimension"],
+    ["cutoff_length",    "Ang", 100.0, [0.0, inf], "", "Cut-off length"],
+]
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/sas_gamma.c", "mass_fractal.c"]
+source = ["lib/sas_3j1x_x.c", "lib/sas_gamma.c", "mass_fractal.c"]
 
 demo = dict(scale=1, background=0,
Index: sasmodels/models/mass_surface_fractal.c
===================================================================
--- sasmodels/models/mass_surface_fractal.c	(revision 30fbe2eda4d6f97acc840bd5e605de3829caf3c7)
+++ sasmodels/models/mass_surface_fractal.c	(revision 6d96b66e1e58166fbc135a8df1ddf8d37f64b54a)
@@ -1,11 +1,5 @@
-double form_volume(double radius);
-
-double Iq(double q,
-          double fractal_dim_mass,
-          double fractal_dim_surf,
-          double rg_cluster,
-          double rg_primary);
-
-static double _mass_surface_fractal_kernel(double q,
+#define INVALID(p) (p.fractal_dim_mass + p.fractal_dim_surf > 6.)
+static double
+Iq(double q,
           double fractal_dim_mass,
           double fractal_dim_surf,
@@ -14,40 +8,11 @@
 {
      //computation
-    double tot_dim = 6.0 - fractal_dim_surf - fractal_dim_mass;
-    fractal_dim_mass /= 2.0;
-    tot_dim /= 2.0;
+    const double Dm = 0.5*fractal_dim_mass;
+    const double Dt = 0.5*(6.0 - (fractal_dim_mass + fractal_dim_surf));
 
-    double rc_norm = rg_cluster * rg_cluster / (3.0 * fractal_dim_mass);
-    double rp_norm = rg_primary * rg_primary / (3.0 * tot_dim);
+    const double t1 = Dm==0. ? 1.0 : pow(1.0 + square(q*rg_cluster)/(3.0*Dm), -Dm);
+    const double t2 = Dt==0. ? 1.0 : pow(1.0 + square(q*rg_primary)/(3.0*Dt), -Dt);
+    const double form = t1*t2;
 
-    //x for P
-    double x_val1 = 1.0 +  q * q * rc_norm;
-    double x_val2 = 1.0 +  q * q * rp_norm;
-
-    double inv_form = pow(x_val1, fractal_dim_mass) * pow(x_val2, tot_dim);
-
-    //another singular
-    if (inv_form == 0.0) return 0.0;
-
-    double form_factor = 1.0;
-    form_factor /= inv_form;
-
-    return (form_factor);
+    return form;
 }
-double form_volume(double radius){
-
-    return 1.333333333333333*M_PI*radius*radius*radius;
-}
-
-double Iq(double q,
-          double fractal_dim_mass,
-          double fractal_dim_surf,
-          double rg_cluster,
-          double rg_primary)
-{
-    return _mass_surface_fractal_kernel(q,
-            fractal_dim_mass,
-            fractal_dim_surf,
-            rg_cluster,
-            rg_primary);
-}
Index: sasmodels/models/mass_surface_fractal.py
===================================================================
--- sasmodels/models/mass_surface_fractal.py	(revision 30fbe2eda4d6f97acc840bd5e605de3829caf3c7)
+++ sasmodels/models/mass_surface_fractal.py	(revision 6d96b66e1e58166fbc135a8df1ddf8d37f64b54a)
@@ -78,14 +78,11 @@
 
 # pylint: disable=bad-whitespace, line-too-long
-#             ["name", "units", default, [lower, upper], "type","description"],
-parameters = [["fractal_dim_mass",      "",    1.8, [1e-16, 6.0], "",
-               "Mass fractal dimension"],
-              ["fractal_dim_surf",   "",    2.3, [1e-16, 6.0], "",
-               "Surface fractal dimension"],
-              ["rg_cluster", "Ang",   86.7, [0.0, inf], "",
-               "Cluster radius of gyration"],
-              ["rg_primary", "Ang", 4000.,  [0.0, inf], "",
-               "Primary particle radius of gyration"],
-             ]
+#   ["name", "units", default, [lower, upper], "type","description"],
+parameters = [
+    ["fractal_dim_mass", "",      1.8, [0.0, 6.0], "", "Mass fractal dimension"],
+    ["fractal_dim_surf", "",      2.3, [0.0, 6.0], "", "Surface fractal dimension"],
+    ["rg_cluster",       "Ang",  86.7, [0.0, inf], "", "Cluster radius of gyration"],
+    ["rg_primary",       "Ang", 4000., [0.0, inf], "", "Primary particle radius of gyration"],
+]
 # pylint: enable=bad-whitespace, line-too-long
 
Index: sasmodels/models/multilayer_vesicle.c
===================================================================
--- sasmodels/models/multilayer_vesicle.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/multilayer_vesicle.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -19,12 +19,12 @@
 
         // layer 1
-        voli = 4.0*M_PI/3.0*ri*ri*ri;
-        fval += voli*sldi*sph_j1c(ri*q);
+        voli = M_4PI_3*ri*ri*ri;
+        fval += voli*sldi*sas_3j1x_x(ri*q);
 
         ri += thick_shell;
 
         // layer 2
-        voli = 4.0*M_PI/3.0*ri*ri*ri;
-        fval -= voli*sldi*sph_j1c(ri*q);
+        voli = M_4PI_3*ri*ri*ri;
+        fval -= voli*sldi*sas_3j1x_x(ri*q);
 
         //do 2 layers at a time
Index: sasmodels/models/multilayer_vesicle.py
===================================================================
--- sasmodels/models/multilayer_vesicle.py	(revision 041bc75e8cfa1c5f0d3188c31fb26e04c4deeebb)
+++ sasmodels/models/multilayer_vesicle.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -107,5 +107,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "multilayer_vesicle.c"]
+source = ["lib/sas_3j1x_x.c", "multilayer_vesicle.c"]
 
 polydispersity = ["radius", "n_pairs"]
Index: sasmodels/models/onion.c
===================================================================
--- sasmodels/models/onion.c	(revision d119f34af4e9929175fc6628b476183ede452a76)
+++ sasmodels/models/onion.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -6,5 +6,5 @@
   const double vol = M_4PI_3 * cube(r);
   const double qr = q * r;
-  const double bes = sph_j1c(qr);
+  const double bes = sas_3j1x_x(qr);
   const double alpha = A * r/thickness;
   double result;
@@ -30,8 +30,8 @@
 
 static double
-form_volume(double core_radius, double n, double thickness[])
+form_volume(double radius_core, double n, double thickness[])
 {
   int i;
-  double r = core_radius;
+  double r = radius_core;
   for (i=0; i < n; i++) {
     r += thickness[i];
@@ -41,10 +41,10 @@
 
 static double
-Iq(double q, double sld_core, double core_radius, double sld_solvent,
+Iq(double q, double sld_core, double radius_core, double sld_solvent,
     double n_shells, double sld_in[], double sld_out[], double thickness[],
     double A[])
 {
   int n = (int)(n_shells+0.5);
-  double r_out = core_radius;
+  double r_out = radius_core;
   double f = f_exp(q, r_out, sld_core, 0.0, 0.0, 0.0, 0.0);
   for (int i=0; i < n; i++){
Index: sasmodels/models/onion.py
===================================================================
--- sasmodels/models/onion.py	(revision 7b68dc576b7995dbf041602384c63c354ea857b5)
+++ sasmodels/models/onion.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -314,5 +314,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "onion.c"]
+source = ["lib/sas_3j1x_x.c", "onion.c"]
 single = False
 
@@ -366,12 +366,12 @@
     return np.asarray(z), np.asarray(rho)
 
-def ER(core_radius, n, thickness):
+def ER(radius_core, n, thickness):
     """Effective radius"""
-    return np.sum(thickness[:int(n[0])], axis=0) + core_radius
+    return np.sum(thickness[:int(n[0])], axis=0) + radius_core
 
 demo = {
     "sld_solvent": 2.2,
     "sld_core": 1.0,
-    "core_radius": 100,
+    "radius_core": 100,
     "n_shells": 4,
     "sld_in": [0.5, 1.5, 0.9, 2.0],
@@ -381,6 +381,6 @@
     # Could also specify them individually as
     # "A1": 0, "A2": -1, "A3": 1e-4, "A4": 1,
-    #"core_radius_pd_n": 10,
-    #"core_radius_pd": 0.4,
+    #"radius_core_pd_n": 10,
+    #"radius_core_pd": 0.4,
     #"thickness4_pd_n": 10,
     #"thickness4_pd": 0.4,
